unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    quitbutton: TButton;
    Memo1: TMemo;
    aboutbutton: TButton;
    subformbutton: TButton;


     // vista compatibility
   procedure AppMinimize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure quitbuttonClick(Sender: TObject);
    procedure aboutbuttonClick(Sender: TObject);
    procedure subformbuttonClick(Sender: TObject);
   // end vista stuff

  private
    { Private declarations }
  public
    { Public declarations }
  protected
   // vista compatibility 
   procedure CreateParams(var Params: TCreateParams); override;
   procedure wm_SysCommand(var M: TMessage); message WM_SYSCOMMAND;
   // end vista stuff
    
  end;

var
  Form1: TForm1;

implementation

uses uVista, Unit2;

{$R *.DFM}

// vista compatibility

procedure TForm1.wm_SysCommand(var M: TMessage);
begin
  if IsWindowsVista then
   begin
     case (M.WParam and $FFF0) of
      SC_MINIMIZE, SC_RESTORE, SC_MAXIMIZE:
       begin
         M.Result := DefWindowProc(self.Handle, M.Msg, M.WParam, M.LParam);
         ShowWindow(Application.Handle, SW_HIDE);
       end;
      else inherited;
     end;
   end
  else inherited;
end;

procedure TForm1.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  if IsWindowsVista then
   Params.ExStyle := Params.ExStyle and not WS_EX_TOOLWINDOW or WS_EX_APPWINDOW;
end;

procedure TForm1.AppMinimize;
begin
  // draw the main form before we minimize it
  ShowWindow(Handle, SW_SHOW); // so Vista can get a thumbnail at startup
  application.processmessages;  // allow time for form to be drawn
  ShowWindow(Handle, SW_MINIMIZE);
end;

// end vista stuff 


procedure TForm1.FormCreate(Sender: TObject);
begin
  // vista compatibility
  if IsWindowsVista then 
   begin
     SetVistaFonts(self);
     Application.OnMinimize := AppMinimize;
     SetVistaContentFonts(memo1.font);
   end; 
  // end vista stuff

  scaled := false;
  position := poScreenCenter;
end;

procedure TForm1.quitbuttonClick(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.aboutbuttonClick(Sender: TObject);
begin
  if IsWindowsVista then
     TaskDialog(form1.handle, 'About',
                           'This is a default Vista application',
                           'For these TaskDialogs to work on XP you need to use '
                           + 'something like "Solway''s TaskDialog", which will '+
                           'emulate the Vista dialogs on earlier operating systems.',
                           TD_ICON_INFORMATION,
                           0)
     else showmessage('This is a default Vista application');                      
end;

procedure TForm1.subformbuttonClick(Sender: TObject);
begin
  try
    form2 := tform2.create(self);
    form2.showmodal;
  finally
    form2.free;
  end;
end;

end.
